
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>iOS深入学习之Weak关键字介绍 / iVAN</title>

    <meta name="description" content="iOS深入学习之Weak关键字介绍 前言 从大二的开始接触OC就用到了weak属性修饰词,但是当时只是知道如何去用这个关键字:防止循环引用.根本没有深入地去了解它. 在刚来北京的时候面试过程中也常常考到该知识点.大点的公司可能会问它如何使用?如何在对象销毁后将对象置nil,小点的公司可能只问一下它的使用. Now,如果你对它产生恐惧或者曾经对它产生过恐惧(+1),如果你被该关键字弄得整天吃不下饭,睡不着觉,那么可以继续往下阅读,希望读过该博客之后能够帮到你. 废话不多说,开始介绍. 由浅入深 先来看看最简单的一个例子: #impo">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">iOS深入学习之Weak关键字介绍</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h5>前言</h5>
<p>从大二的开始接触OC就用到了weak属性修饰词，但是当时只是知道如何去用这个关键字：防止循环引用。根本没有深入地去了解它。<br />
在刚来北京的时候面试过程中也常常考到该知识点。大点的公司可能会问它如何使用？如何在对象销毁后将对象置nil，小点的公司可能只问一下它的使用。<br />
Now，如果你对它产生恐惧或者曾经对它产生过恐惧（+1），如果你被该关键字弄得整天吃不下饭，睡不着觉，那么可以继续往下阅读，希望读过该博客之后能够帮到你。<br />
废话不多说，开始介绍。</p>
<h5>由浅入深</h5>
<p>先来看看最简单的一个例子：</p>
<pre><code>#import "ViewController.h"

@interface ViewController ()

@property (nonatomic,strong)id strongPoint;
@property (nonatomic,weak)id weakPoint;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
//    self.strongPoint = [NSDate date];
    self.strongPoint = [[UILabel alloc] init];
    self.weakPoint = self.strongPoint;
    self.strongPoint = nil;
    NSLog(@"result is :%@", self.weakPoint);
}
@end</code></pre>
<p>我们可以看到此时输出的结果为：</p>
<p>2017-02-07 13:20:41.119278 Test[7341:2187477] result is :(null)</p>
<p>如果我们使用的strong来修饰weakPoint，此时输出的结果为：</p>
<p>2017-02-07 13:23:13.211164 Test[7344:2187993] result is :&lt;UILabel: 0x100206070; frame = (0 0; 0 0); userInteractionEnabled = NO; layer = &lt;_UILabelLayer: 0x17009a590&gt;&gt;</p>
<p>如果我们使用assign来修饰weakPoint，此时运行程序可能会崩溃（因为如果引用操作发生时内存还没有改变内容，依旧可以输出正确结果，如果引用的时候内存内容发生改变了，就会crash），因为当assign指针所指向的内存被释放之后，不会自动赋值为nil，这样再次引用该指针的时候就会导致野指针操作。<br />
对上述代码运行结果进行分析：<br />
当使用weak关键字的时候，不会增加对象的计数，而且当所指对象置nil的时候，使用weak修饰的指针将被赋值为nil；<br />
当使用strong关键字的时候，会增加对象的计数，也就是说会保持对象值的存在，所以当使用strong的时候weakPoint还会有值。<br />
因此，我们从这里可以得出一个结果：<br />
strong是强引用，它会保持对象值的存在；<br />
weak是弱引用，当weak指针指向的对象摧毁之后，属性值也会清空(nil out)。<br />
(注意：使用 _ _ weak修饰 和在@ property里面设置weak是一样的)<br />
但是当我们执行如下代码的时候：</p>
<pre><code>__strong NSString *yourString = @"Your String";
__weak NSString *myString = yourString;
yourString = nil;
__unsafe_unretained NSString *theirString = myString;
NSLog(@"%p %@", yourString, yourString);
NSLog(@"%p %@", myString, myString);
NSLog(@"%p %@", theirString, theirString);</code></pre>

<hr>
<br />你会发现只有yourString为空，其他两个都不为空，这个是为什么呢？原因如下</p>
<hr>
<br />这里是因为字符字面值永远不会被释放，所以你的weak指针还是指向它。<br /><a>当你使用@""创建一个string对象的时候</a>，它就是一个字面值，永远不会被改变。如果你在程序中很多地方都用到了一样的字符串，那么你可以测试一下，它们都是同一个对象（地址一样），String字面值不会销毁。使用[[NSString alloc] initWithString:@"literal string"]也是一样的效果。因为它指向了一个字面值的string。</p>
<hr>
<br />那么请问weak指针指向对象被回收的时候该指针是如何被自动置为nil的呢？？</p>
<hr>
<br />首先，大家可以看一下博客最后面的附录，里面有两个文档，严格来说是Apple的opensouce。里面有一个objc-weak的类。这里是一个objc-weak.h类和一个objc-weak.mm类。</p>
<pre><code>扩展常识
.m和.mm的区别
.m：源代码文件，这个典型的源代码文件扩展名，可以包含OC和C代码。
.mm：源代码文件，带有这种扩展名的源代码文件，除了可以包含OC和C代码之外，还可以包含C++代码。仅在你的OC代码中确实需要使用C++类或者特性的时候才用这种扩展名。</code></pre>
<p>从.h中可以看到以下几个关键的两个结构体：weak_entry_t和weak_table_t，以及一些方法。接下来简单介绍一下weak如何自动置为nil。<br />
weak的实现其实是一个weak表，该表是一个由<a href="http://baike.baidu.com/link?url=FJL2Ca2uiGBNzZ7bieAbeUcFs54tZzOM_FFNnuaPKd9gA6-Rzvhh3-eKbK58WXizDkjq7-P5hbBjnAPHwPUJoSOYgSq5gDzp0KE0pbLf0hpIYxsQXhtlUF1E4YxcP2hf" rel="external nofollow noreferrer">自旋锁</a>管理的哈希表。<br />
以下是从NSObject.mm里面摘出的一些方法：</p>
<pre><code>id
objc_initWeak(id *location, id newObj)
{
    if (!newObj) {
        *location = nil;
        return nil;
    }

    return storeWeak&lt;false/*old*/, true/*new*/, true/*crash*/&gt;
        (location, (objc_object*)newObj);
}</code></pre>
<p>该function的作用是初始化一个新的weak指针指向对象的地址。其中的参数介绍如下：</p>
<ul>
<li>location段：_ _ weak指针的地址</li>
<li>newObj：对象的指针地址</li>
</ul>
<p>这里调用的storeWeak方法，storeWeak方法里面通过template模板的参数进行更新weak操作，看源码可以知道里面会调用weak_register_no_lock/weak_unregister_no_lock等objc-weak.mm里面的方法进行相应的操作。objc-weak.h里面有句话：</p>
<pre><code>For ARR, we also keep track of whether an arbitrary object is being
deallocated by briefly placing it in the table just prior to invoking
dealloc, and removing it via objc_clear_deallocating just prior to memory
reclamation.</code></pre>
<p>对象被废弃时最后调用objc_clear_deallocating。该函数实现如下：</p>
<pre><code>void
objc_clear_deallocating(id obj)
{
    assert(obj);
    assert(!UseGC);

    if (obj-&gt;isTaggedPointer()) return;
    obj-&gt;clearDeallocating();
}</code></pre>
<p>也就是调用了clearDeallocating，继续追踪可以发现，它最终是使用了迭代器来取weak表的value，然后调用weak_clear_no_lock,然后查找对应的value，将该weak指针置空：</p>
<pre><code>/**
 * Called by dealloc; nils out all weak pointers that point to the
 * provided object so that they can no longer be used.
 *
 * @param weak_table
 * @param referent The object being deallocated.
 */
void
weak_clear_no_lock(weak_table_t *weak_table, id referent_id)
{
    objc_object *referent = (objc_object *)referent_id;

    weak_entry_t *entry = weak_entry_for_referent(weak_table, referent);
    if (entry == nil) {
        /// XXX shouldn't happen, but does with mismatched CF/objc
        //printf("XXX no entry for clear deallocating %p\n", referent);
        return;
    }

    // zero out references
    weak_referrer_t *referrers;
    size_t count;

    if (entry-&gt;out_of_line) {
        referrers = entry-&gt;referrers;
        count = TABLE_SIZE(entry);
    }
    else {
        referrers = entry-&gt;inline_referrers;
        count = WEAK_INLINE_COUNT;
    }

    for (size_t i = 0; i &lt; count; ++i) {
        objc_object **referrer = referrers[i];
        if (referrer) {
            if (*referrer == referent) {
                *referrer = nil;
            }
            else if (*referrer) {
                _objc_inform("__weak variable at %p holds %p instead of %p. "
                             "This is probably incorrect use of "
                             "objc_storeWeak() and objc_loadWeak(). "
                             "Break on objc_weak_error to debug.\n",
                             referrer, (void*)*referrer, (void*)referent);
                objc_weak_error();
            }
        }
    }

    weak_entry_remove(weak_table, entry);
}
</code></pre>
<p>objc_clear_deallocating该函数的动作如下：</p>
<ol>
<li>从weak表中获取废弃对象的地址为键值的记录</li>
<li>将包含在记录中的所有附有 _ _ weak修饰符变量的地址，赋值为nil</li>
<li>将weak表中删除该记录</li>
<li>从引用计数表中删除废弃对象的地址为键值的记录<br />
看了objc-weak.mm的源码大概了解了：其实Weak表示一个hash表，然后里面的key是指向对象的地址，Value是Weak指针的地址的数组。</li>
</ol>
<h5>结束</h5>
<p>以上便是我个人对weak的理解，查看objc4的源码，发现里面更多的都是结构体、结构体套结构体等等。</p>
<h5>附录</h5>
<ol>
<li>Apple的<a href="https://opensource.apple.com/source/objc4/objc4-646/runtime/objc-weak.h" rel="external nofollow noreferrer">opensource</a>。</li>
<li>Apple的<a href="https://github.com/opensource-apple" rel="external nofollow noreferrer">github</a>。</li>
<li><a href="http://stackoverflow.com/questions/10922888/weak-nsstring-variable-is-not-nil-after-setting-the-only-strong-reference-to-nil" rel="external nofollow noreferrer">stackoverflow</a>。</li>
</ol>
<h5>原文链接</h5>
<p><a href="http://supermokey.com/2017/02/08/weak/" rel="external nofollow noreferrer">点此</a>。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 02:26:26</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/ios/" title="ios">ios</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/weak/" title="weak">weak</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>iOS深入学习之Weak关键字介绍的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/balQWgz.html" rel="bookmark">开源中国iOS客户端学习 &lpar;十二&rpar; 用户登陆</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇博客  开源中国iOS客户端学习--(十一)AES加密 中提到将用户名和密码保存到了本地沙盒之中,在从本地读取用户名和密码,这是一个怎样的过程? -(void)saveUserNameAndPwd:(NSString *)userName andPwd:(NSString *)pwd { NSUserDefaults * settings = [NSUserDefaults standardUserDefaults]; [settings removeObjectForKey:@&quot;User			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3N8VNz.html" rel="bookmark">IOS基础学习UIButton使用详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  UIButton按钮是IOS开发中最常用的控件,作为IOS基础学习教程知识 ,初学者需要了解其基本定义和常用设置,以便在开发在熟练运用. 第一.UIButton的定义 UIButton *button=[[UIButton buttonWithType:(UIButtonType); 能够定义的button类型有以下6种, typedef enum { UIButtonTypeCustom = 0, 自定义风格 UIButtonTypeRoundedRect, 圆角矩形 UIButtonTy			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwx7l5b.html" rel="bookmark">iOS开发拓展篇-XMPP简单介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				iOS开发拓展篇-XMPP简单介绍 一.即时通讯简单介绍 1.简单说明 即时通讯技术(IM)支持用户在线实时交谈.如果要发送一条信息,用户需要打开一个小窗口,以便让用户及其朋友在其中输入信息并让交谈双方都看到交谈的内容 有许多的IM系统,如AOL IM.Yahoo IM. MSN以及QQ,它们最大的区别在于各自通讯协议的实现,所以即时通讯技术的核心在于它的传输协议 协议用来说明信息在网络上如何传输,如果有了统一的传输协议,那么应当可以实现各个IM之间的直接通讯,为了创建即时通讯的统一标准,目前已			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba7P6Qp.html" rel="bookmark">iOS之学习资源收集--很好的IOS技术学习网站</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				点击图片也能打开相关的网站: The AppGuruz:http://www.theappguruz.com/category/ios 也是一个国外的网站,但是包含了IOS的学习内容 https://spin.atomicobject.com/?s=IOS : 很好的国外英文IOS学习网站 ,内容很丰富哦,耐心学习,英语阅读水平也会提高的:http://www.techotopia.com/index.php/IOS_iPhone_iPad_eBooks 下面这个https://github.c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pP8QRmp.html" rel="bookmark">iOS开发-常用第三方开源框架介绍&lpar;你了解的ios只是冰山一角&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图像: 1.图片浏览控件MWPhotoBrowser        实现了一个照片浏览器类似 iOS 自带的相册应用,可显示来自手机的图片或者是网络图片,可自动从网络下载图片并进行缓存.可对图片进行缩放等操作.       下载:https://github.com/mwaterfall/MWPhotoBrowser   目前比较活跃的社区仍旧是Github,除此以外也有一些不错的库散落在Google Code.SourceForge等地方.由于Github社区太过主流,这里主要介绍一下Gith			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkwjv7p.html" rel="bookmark">iOS ARC学习汇总</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ARC ARC是什么 ARC是iOS 5推出的新功能,全称叫 ARC(Automatic Reference Counting).简单地说,就是编译阶段自动做了retain/release,原先需要手动添加的用来处理内存管理的引用计数的代码可以自动地由编译器完成了.就ARC并不是GC,不是运行时内存管理,不会做malloc/free的工作,它只是一种代码静态分析(Static Analyzer)工具. 比如,我们生成一个对象: addretain.png 编译器会给我们添加上retain/rel			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlmraNp.html" rel="bookmark">JavaScript Event事件学习第一章 Event介绍&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				没有event就没有脚本.可以看看任何有JavaScript代码的网页:几乎所有的例子都有一个事件触发了脚本.原因非常简单.JavaScript就是给你的页面添加内部活动:用户做一些事情然后页面做出回应. 因此JavaScript就需要一个方法能够检测到用户的动作然后才能知道什么时候做出反应.这还需要知道那个函数会被执行,函数会做一些你认为的给你的网页增色的动作.这些文字描述了如何去写这样的脚本.虽然不容易,但是这是一个很让人满足的工作. 当用户做了什么事情event就发生了,当然还有一些eve			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z43yJNp.html" rel="bookmark">iOS 逆向工程 - 学习整理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.class-dump 简介:顾名思义,就是用来导出目标对象的class信息的工具,私有方法声明也能导出来. 原理:利用 Objective-C语言的 runtime 特性,将存 在Mach-O 文件中的头文件信息提 出来,并生成对应的 .h 文件. 使用方法: 1,下载然后将class-dump 复制到&quot; /usr/bin&quot;目录下. 2,执行sudo chmod 777 /usr/bin/class-dump&quot;命令赋予其执行权限. 3,class-dump执行: clas			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgPe8p.html" rel="bookmark">开源中国iOS客户端学习 &lpar;十一&rpar; AES加密</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据加密在解密在软件开发过程中举足轻重的作用,可能有的公司在加密的时候有自己公司内部一套设计的算法,而在这方面不想浪费太大精力就可以去考虑使用第三方提供的加密算法,如AES加密算法,本篇内容介绍开源中国iOS客户端使用ASE算法加密密码: AES   GitHub 下载地址  https://github.com/Gurpartap/AESCrypt-ObjC 对一个比较大的工程我们可能都不知道某个类库或者方法在哪被使用,但是智能的Xcode给我们提供了一个全局搜索的功能,我们可以在真个工程中来			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmGmab.html" rel="bookmark" class="title">Java的Package与Import机制之我的理解&lpar;初学者的心得&rpar;</a>
					<div>
						初学|心得    以下内容的测试条件是你的机器上,设置了path命令PATH= D:\JDK1.4\BIN;D:\JDK1.4\LIB;,可以正常执行java和javac命令,不用设置classpat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvYOVb.html" rel="bookmark" class="title">集中权限管理系统-java 跨域单点登录结合集中权限管理 权限控制采用shiro</a>
					<div>
						问题描述 java 跨域单点登录结合集中权限管理 权限控制采用shiro 这种需求的系统谁做过 之前 参考了 网上博客的 oauth2 但是发现不太符合我这个需求 因为oauth2只是授权 并不能解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7GLAz.html" rel="bookmark" class="title">Eclipse发布AspectJ 5 正式版</a>
					<div>
						AspectJ 5 正式版 发布了. Eclipse提到: At long last, we're delighted to say that AspectJ 5 is here in time fo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDvNXM.html" rel="bookmark" class="title">PHP实现短网址开源API，不需DB</a>
					<div>
						  配置文件 &lt;?php /*网址设置*/ define(SITE,&quot;http://xxx.com&quot;);//域名后面不要加/ /*API设置*/ define(API_KEY ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQ2QGM.html" rel="bookmark" class="title">浅谈不同域名对于百度权重的影响</a>
					<div>
						随着域名注册用户的增多,.com后缀的简短好记的域名资源近乎枯竭,退而求其次的选择了net/.cn/.org等域名来做门户网站也是大家早已习惯的事情.而为了寻找更简短的更加符合网站名称和定位的域名,个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBvrAb.html" rel="bookmark" class="title">再学GDI&plus;&lbrack;95&rsqb;&colon; TGPImage&lpar;15&rpar;</a>
					<div>
						我通过做此例同时证实了 GDI+ 可以直接显示 png.gif.tif 格式的透明图片. //红色与绿色绕蓝色旋转(r 是弧度) ColorMatrix: TColorMatrix = ( (Cos( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrPKJp.html" rel="bookmark" class="title">UVa 156 Ananagrams：用STL multimap&amp;amp&semi;amp&semi;set处理字典中的重复元素</a>
					<div>
						156 - Ananagrams Time limit: 3.000 seconds http://uva.onlinejudge.org/index.php?option=com_onlinejud ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4qyOp.html" rel="bookmark" class="title">flash player安装为什么老是错误</a>
					<div>
						  flash player安装老是错误解决方法一: 第一步. 开始--设置--控制面板--双击添加与删除程序,卸载掉flash等相关文件. 第二步. C:WINDOWSsystem32Macrome ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5oR27b.html" rel="bookmark" class="title">Photoshop制作图片透明水印教程</a>
					<div>
						使用PS制作透明水印的方法,主要通过输入文字,添加图层样式完成最终效果,朋友们可以自己动手试下,制作一个属于自己的水印吧. 我们见过很多水印,有没有想过自己做一个呀,呵呵,很简单哈,下面我们一起练习一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3078M.html" rel="bookmark" class="title">win7系统扫描仪在哪？win7扫描仪在哪打开？</a>
					<div>
						  win7系统扫描仪在哪?win7扫描仪在哪打开?自从XP停止服务之后,很多用户都换上了win7系统,虽然win7系统早已被大部分用户所熟悉,但是一些小的设置方面还是需要了解一下的,比如很多时候我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6aA1b.html" rel="bookmark" class="title">笔记本电脑的USB接口不能使用怎么办？</a>
					<div>
						  笔记本电脑USB接口不工作的问题是比较常见的,很多用户都遇到过.出现这种问题时,可以从以下几个方面尝试解决. 1.在BIOS中检查USB口是否设置成了Enabled. 2.重新拔插USB设备,检查 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o5dwb.html" rel="bookmark" class="title">ip-怎么制造并捕获IP分片</a>
					<div>
						问题描述 怎么制造并捕获IP分片 1.用ping命令制造IP分片(具体选型看帮助). 2.用wireshark捕捉IP分片(从哪里看出是分片.从哪里看出分片是第几个分片). 3.ping 127.0. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOlwXxb.html" rel="bookmark" class="title">JavaScript中读取和保存文件实例&lowbar;javascript技巧</a>
					<div>
						话说今天只是粗略浏览了一下Proxy SwitchySharp的源码,就收获了不少东西,其中就包括本文要介绍的读取和保存文件. 因为Google还不提供同步插件数据的功能,所以导入和导出插件配置就必须 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQAvVp.html" rel="bookmark" class="title">Android--锁定横屏、竖屏、去标题全屏</a>
					<div>
						xml文件中设置: 要实现这个目的,只需要在AndroidManifest.xml里声明Activity的时候加上一个属性:Android:screenOrientation,属性取值landscap ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxoV9Pb.html" rel="bookmark" class="title">Linux&lowbar;用户和权限管理</a>
					<div>
						目录 目录 用户管理基础知识 用户管理指令 useradd userdel passwd usermod chage su id who chmod chown s权限t权限 acl 用户管理基础知识 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm682wz.html" rel="bookmark" class="title">javaIO错误，会的请指点。</a>
					<div>
						问题描述 public class Test1 {private static String getStaticPage(String surl) {String htmlContent = &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmmo5b.html" rel="bookmark" class="title">查询中出现ADODB&period;Recordset &amp;amp&semi;amp&semi;&num;x27&semi;800a0bb9&amp;amp&semi;amp&semi;&num;x27&semi; 的错误</a>
					<div>
						问题描述 &lt;%setrs=server.CreateObject(&quot;ADODB.Recordset&quot;)sqll=&quot;SELECT*fromQZ_rencai&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKjBEb.html" rel="bookmark" class="title">购物车该怎么设计</a>
					<div>
						这篇文章不是讨论电商的购物车的流程设计,UI设计,这些都是用户购物的过程.我们应该关心,用户把东西放到购物车里面之后,接下来会怎么样. 先调查一下,各位觉得,PC上,APP上,WAP上,对同一个用户, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWoQEz.html" rel="bookmark" class="title">ios开发-为什么我在AppDelegate中发送通知，在想要接受通知的地方并没有触发selector&quest;</a>
					<div>
						问题描述 为什么我在AppDelegate中发送通知,在想要接受通知的地方并没有触发selector? 为什么我在AppDelegate中发送通知,在想要接受通知的地方并没有触发selector? 真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7JEGz.html" rel="bookmark" class="title">mfc-vc6&period;0怎么用一个按钮控制两个图片</a>
					<div>
						问题描述 vc6.0怎么用一个按钮控制两个图片 本来是图片1,按下按钮后就变成图片2,再按就是图片1,如此来回切换 解决方案 变量一个全局的 BOOL 型变量,每按一次按键这个 BOOL 变量取反.然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M609DNz.html" rel="bookmark" class="title">美国域名再现负增长 5月上旬损失超1&period;2万个</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 据域名统计机构WebHosting ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7oPmM.html" rel="bookmark" class="title">PHP PDO函数库（PDO Functions）第1&sol;2页&lowbar;php技巧</a>
					<div>
						与ADODB和MDB2相比,PDO更高效.目前而言,实现&quot;数据库抽象层&quot;任重而道远,使用PDO这样的&quot;数据库访问抽象层&quot;是一个不错的选择. PDO-&gt;be ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7A7eM.html" rel="bookmark" class="title">Oracle中SPOOL命令使用方法详解</a>
					<div>
						举例:test.sh  代码如下 复制代码 #! /bin/sh sqlplus -s scott/tiger&lt;&lt;EOF  set head off  set linesize 20000 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKEd5z.html" rel="bookmark" class="title">如何查看extjs中的依赖</a>
					<div>
						问题描述 各位大虾,请问有没有人比较熟悉extjs.我现在在学这方面的东西.小弟遇到了一个问题,当我们做自己的js文件时,通过将几个source包里面的.js文件合并到一个.js中,有时涉及到了依赖. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWkWmM.html" rel="bookmark" class="title">英特尔与Cloudera强化战略合作：大数据掘金</a>
					<div>
						由英特尔公司和Cloudera公司联合举办的主题为&quot;强强联手 聚焦中国 领航大数据&quot;的合作启动仪式暨新闻发布会,继昨日于上海成功召开后,今日到访北京.双方宣布将不断加强战略合作伙伴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Nv4Rp.html" rel="bookmark" class="title">PHP错误：Forbidden You don&amp;amp&semi;&num;39&semi;t have permission to access &sol; on this server&period;</a>
					<div>
						原文:PHP错误:Forbidden You don't have permission to access / on this server. 今天老大让在xp下搭建一个FTP服务器,一波三折,最后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKm74z.html" rel="bookmark" class="title">No valid host was found</a>
					<div>
						问题描述 使用三个虚拟机安装openstackicehouse,OS版本为ubuntu-14.04-server-amd64,一个controllernode,一个neutronnode,一个netw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5YdJnp.html" rel="bookmark" class="title">《CCNP安全防火墙642-618认证考试指南》&mdash;&mdash;导读</a>
					<div>
						目 录 前言 第 1章 Cisco ASA自适应安全设备概述 1.1 &quot;我已经知道了吗?&quot;测试题 1.2 基本主题1.3 防火墙概述 1.4 防火墙技术 1.5 Cisco ASA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJe408p.html" rel="bookmark" class="title">关于反射</a>
					<div>
						问题描述 什么是反射能否举个例子说明一下还有那个dll文件怎么生成看了好多网页看不懂啊 解决方案 解决方案二:按我的理解反射,用个比较土的解释假如有你有个朋友,你想看他肚子里有几条蛔虫,那么你可以用个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgWom3M.html" rel="bookmark" class="title">恶意木马新变种可自动加载运行</a>
					<div>
						据新华社电 (记者张建新)国家计算机病毒应急处理中心12日发布信息称,一种恶意木马程序的新变种Trojan_PSW.Alipay出现.该变种在以前版本的基础上,会利用某些下载工具.浏览器IE和一些购物 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
